//|==================================================================|
//|Copyright  2008, Brandon Wilhite								 |                             
//|Brandon Wilhite licenses this file                                |
//|to you under the Apache License, Version 2.0 (the                 |
//|"License"); you may not use this file except in compliance        |
//|with the License.  You may obtain a copy of the License at        |
//|                                                                  |                                                                 |
//|http://www.apache.org/licenses/LICENSE-2.0                        |
//|                                                                  |                                                                 |   
//|Unless required by applicable law or agreed to in writing,        |
//|software distributed under the License is distributed on an       |
//|"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY            |
//|KIND, either express or implied.  See the License for the         |
//|specific language governing permissions and limitations           |
//|under the License.                                                |                                                    |
//+------------------------------------------------------------------+
#define WIN32_LEAN_AND_MEAN  // Exclude rarely-used stuff from Windows headers
#include "stdafx.h"
#include <map>
#include <queue>
#include <vector>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

using namespace std;

#define MT4_EXPFUNC __declspec(dllexport)

#define msg(m,t) MessageBox(NULL,m,t,NULL)

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

//+------------------------------------------------------------------+
//|																	 |
//+------------------------------------------------------------------+
static int myClientIds = 0;
MT4_EXPFUNC int __stdcall GetNextClientId()
{
	int toReturn = 0;

	myClientIds++;

	toReturn = myClientIds;

	return (toReturn);
}


static map<int,vector<char*>> tradeEvents;
static vector<int> clientIds;
static map<int,vector<int>> clientMasks;
static queue<char*> tempQueue;

char* IntToString(int someInt)
{
	char buffer[65];
	_itoa(someInt,buffer,10);
	//stringstream ss;
    //ss << someInt;
    return (buffer);
}
int FindClientId(vector<int> someList, int someClientId)
{
	int toReturn = -1;

	for(int i = 0; i < someList.size(); i++)
	{
		if(someList[i] == someClientId)
		{
			toReturn = someList[i];
			break;
		}
	}

	return (toReturn);
}
///Registering, un-registering
MT4_EXPFUNC bool __stdcall TradeEventsRegisterClient(int someClientId)
{
	bool toReturn = false;

	if(tradeEvents.find(someClientId) == tradeEvents.end())
	{
		//prepare the tradeEvents queue for this client Id
		//tradeEvents[someClientId].push("EMPTY");
		//tradeEvents[someClientId].pop();
		tradeEvents[someClientId].push_back("EMPTY");
		tradeEvents[someClientId].pop_back();

		//prepare the client mask
		if(clientMasks.find(someClientId) == clientMasks.end())
		{
			clientMasks[someClientId].push_back(0);
			clientMasks[someClientId].clear();
		}

		//prepare the client Ids tracking
		if(FindClientId(clientIds,someClientId) == -1)
		{
			clientIds.push_back(someClientId);
		}

		toReturn = true;
	}

	return (toReturn);
}

MT4_EXPFUNC bool __stdcall TradeEventsUnregisterClient(int someClientId)
{
	bool toReturn = false;

	if(tradeEvents.find(someClientId) != tradeEvents.end())
	{
		tradeEvents.erase(someClientId);

		if(clientMasks.find(someClientId) == clientMasks.end())
		{
			//delete the client masks
			clientMasks[someClientId].clear();
			clientMasks.erase(someClientId);
		}

		//remove the client Id from tracking
		int locClientIndex = FindClientId(clientIds,someClientId);
		if(locClientIndex != -1 && locClientIndex < clientIds.size())
		{
			clientIds[locClientIndex] = 0;
		}

		toReturn = true;
	}

	return (toReturn);
}

///Message queue
MT4_EXPFUNC bool __stdcall TradeEventsPutMessage(int someClientId, char* someMessage)
{
	bool toReturn = false;

	if(tradeEvents.find(someClientId) != tradeEvents.end())
	{
		/*
		if(!tradeEvents[someClientId].empty())
		{
			msg(tradeEvents[someClientId].back(),"End element");
			msg(tradeEvents[someClientId].front(),"Front element");
		}
		else
		{
			msg("First element in the queue.","");
		}
		msg(someMessage,"Received Message");*/

		//char toPut[80];
		//strcpy_s(toPut,80,someMessage);
		//strcpy(toPut,someMessage);
		//msg(toPut,"Pushing Message");

		//tradeEvents[someClientId].push(someMessage);
		tradeEvents[someClientId].push_back(someMessage);

		/*
		if(!tradeEvents[someClientId].empty())
		{
			msg(tradeEvents[someClientId].back(),"End element");
			msg(tradeEvents[someClientId].front(),"Front element");
		}
		*/
		toReturn = true;
	}

	return (toReturn);
}

MT4_EXPFUNC char* __stdcall TradeEventsGetMessage(int someClientId)
{
	char* toReturn = "";

	if(tradeEvents.find(someClientId) != tradeEvents.end() && !tradeEvents[someClientId].empty())
	{
		toReturn = tradeEvents[someClientId].back();
		tradeEvents[someClientId].pop_back();
		//toReturn = tradeEvents[someClientId].front();
		//tradeEvents[someClientId].pop();
	}

	//msg(toReturn,"Returning Message.");

	return (toReturn);
}
///Masks
MT4_EXPFUNC bool __stdcall TradeEventsContainsFlag(int someClientId, int someFlag)
{
	//msg("TradeEventsContainsFlag(): Checking for client #",IntToString(someClientId));
	bool toReturn = false;

	if(clientMasks.find(someClientId) != clientMasks.end())
	{
		//msg("Found the client.","");
		for(int i = 0;i < clientMasks[someClientId].size(); i++)
		{
			//msg(IntToString(clientMasks[someClientId][i]),"Found mask");
			if(clientMasks[someClientId][i] == someFlag)
			{
				//msg("Found the flag ",IntToString(someFlag));
				toReturn = true;
				break;
			}
		}
	}

	return (toReturn);
}
MT4_EXPFUNC void __stdcall TradeEventsPutMask(int someClientId, int someFlag)
{
	clientMasks[someClientId].push_back(someFlag);
}
///Temporary queue
MT4_EXPFUNC bool __stdcall TradeEventsPutTempQueue(char* someMessage)
{
	bool toReturn = false;

	tempQueue.push(someMessage);
	toReturn = true;

	return (toReturn);
}

MT4_EXPFUNC char* __stdcall TradeEventsGetTempQueue()
{
	char* toReturn = "EMPTY";

	if(!tempQueue.empty())
	{
		toReturn = tempQueue.front();
		tempQueue.pop();
	}

	return (toReturn);
}

MT4_EXPFUNC void __stdcall TradeEventsClearTempQueue()
{
	while(!tempQueue.empty())
	{
		tempQueue.pop();
	}
}

///Client Ids tracking
MT4_EXPFUNC int __stdcall TradeEventsClientIdsTotal()
{
	int toReturn = 0;

	toReturn = clientIds.size();

	return (toReturn);
}
MT4_EXPFUNC int __stdcall TradeEventsGetClientId(int someIndex)
{
	int toReturn = -1;

	if(someIndex >= 0 && someIndex < clientIds.size())
	{
		toReturn = clientIds[someIndex];
	}

	return (toReturn);
}
MT4_EXPFUNC int __stdcall TradeEventsGetClientIdPosition(int someClientId)
{
	int toReturn = -1;

	toReturn = FindClientId(clientIds, someClientId);

	return (toReturn);
}
/*

MT4_EXPFUNC int __stdcall TradeEventsMaskSize(int someClientId)
{
	int toReturn = 0;

	if(clientMasks.find(someClientId) != clientMasks.end())
	{
		toReturn = clientMasks[someClientId].size();
	}

	return (toReturn);
}
MT4_EXPFUNC int __stdcall TradeEventsGetMask(int someClientId, int someIndex)
{
	int toReturn = -10;

	if(clientMasks.find(someClientId) != clientMasks.end())
	{
		if(someIndex <= (clientMasks[someClientId].size() - 1))
		{
			toReturn = clientMasks[someClientId][someIndex];
		}
	}

	return (toReturn);
}



*/